#ifndef _PHP_SCACHE_ARGINFO_H_
#define _PHP_SCACHE_ARGINFO_H_

/* arginfo is mandatory with php8, but disable forced typechecking
 * to avoid need of typing inherited classes */
#define __PHP8_RELAXED_ARGS

/* manually maintained... for understanding and clarity */
#if PHP_MAJOR_VERSION >= 8

# ifdef __PHP8_RELAXED_ARGS

/* scache_open, scache_popen,
   scache_reset, scache_preset */
ZEND_BEGIN_ARG_INFO_EX(aif_open, 0, 0, 5)
    ZEND_ARG_INFO(0, id)
    ZEND_ARG_INFO(0, host)
    ZEND_ARG_INFO(0, expire)
    ZEND_ARG_INFO(0, port)
    ZEND_ARG_INFO(0, flags)
ZEND_END_ARG_INFO()

/* scache_connect, scache_pconnect */
ZEND_BEGIN_ARG_INFO_EX(aif_connect, 0, 0, 4)
    ZEND_ARG_INFO(0, id)
    ZEND_ARG_INFO(0, host)
    ZEND_ARG_INFO(0, secret)
    ZEND_ARG_INFO(0, port)
ZEND_END_ARG_INFO()

/* scache_connect_fast, scache_pconnect_fast */
ZEND_BEGIN_ARG_INFO_EX(aif_connect_fast, 0, 0, 5)
    ZEND_ARG_INFO(0, id)
    ZEND_ARG_INFO(0, index)
    ZEND_ARG_INFO(0, host)
    ZEND_ARG_INFO(0, secret)
    ZEND_ARG_INFO(0, port)
ZEND_END_ARG_INFO()

/* scache_rename */
ZEND_BEGIN_ARG_INFO_EX(aif_rename, 0, 0, 2)
    ZEND_ARG_INFO(0, session)
    ZEND_ARG_INFO(0, newid)
ZEND_END_ARG_INFO()

/* scache_drop */
ZEND_BEGIN_ARG_INFO_EX(aif_drop, 0, 0, 1)
    ZEND_ARG_INFO(0, session)
ZEND_END_ARG_INFO()

/* scache_getopt */
ZEND_BEGIN_ARG_INFO_EX(aif_getopt, 0, 0, 2)
    ZEND_ARG_INFO(0, session)
    ZEND_ARG_INFO(0, opt)
ZEND_END_ARG_INFO()

/* scache_setopt */
ZEND_BEGIN_ARG_INFO_EX(aif_setopt, 0, 0, 3)
    ZEND_ARG_INFO(0, session)
    ZEND_ARG_INFO(0, opt)
    ZEND_ARG_INFO(0, newval)
ZEND_END_ARG_INFO()

/* scache_srvstats */
ZEND_BEGIN_ARG_INFO_EX(aif_srvstats, 0, 0, 1)
    ZEND_ARG_INFO(0, session)
ZEND_END_ARG_INFO()

/* scache_getindex, scache_lasterr */
# define aif_seslong aif_srvstats

/* scache_strerror */
ZEND_BEGIN_ARG_INFO_EX(aif_strerror, 0, 0, 1)
    ZEND_ARG_INFO(0, errcode)
ZEND_END_ARG_INFO()

/* scache_iov */
ZEND_BEGIN_ARG_INFO_EX(aif_iov, 0, 0, 2)
    ZEND_ARG_INFO(0, session)
    ZEND_ARG_INFO(0, iops)
ZEND_END_ARG_INFO()

/* scache_(sh)get, scache_chget, 
   scache_rnpop, scache_rnshift, scache_rnget */
ZEND_BEGIN_ARG_INFO_EX(aif_get, 0, 0, 2)
    ZEND_ARG_INFO(0, session)
    ZEND_ARG_INFO(0, path)
ZEND_END_ARG_INFO()

/* scache_(sh)unset, scache_(sh)clear, scache_(sh)exists, 
   scache_chclear, scache_rnclear */
# define aif_bool aif_get

/* scache_(sh)get, scache_(sh)add, scache_(sh)replace,
   scache_rnpush, scache_snunshift, scache_chput */
ZEND_BEGIN_ARG_INFO_EX(aif_set, 0, 0, 3)
    ZEND_ARG_INFO(0, session)
    ZEND_ARG_INFO(0, path)
    ZEND_ARG_INFO(0, val)
ZEND_END_ARG_INFO()

/* scache_(sh)stat */
# define aif_long aif_get

/* scache_(sh)coll, scache_(sh)move */
ZEND_BEGIN_ARG_INFO_EX(aif_fromto, 0, 0, 3)
    ZEND_ARG_INFO(0, session)
    ZEND_ARG_INFO(0, path)
    ZEND_ARG_INFO(0, to)
ZEND_END_ARG_INFO()

/* scache_vset, scache_vsub, scache_vadd */
# define aif_vset aif_set

/* scache_rnrotf, scache_rnrotb */
ZEND_BEGIN_ARG_INFO_EX(aif_roll, 0, 0, 3)
    ZEND_ARG_INFO(0, session)
    ZEND_ARG_INFO(0, path)
    ZEND_ARG_INFO(0, hops)
ZEND_END_ARG_INFO()

/* class interface */
ZEND_BEGIN_ARG_INFO_EX(aic___construct, 0, 0, 7)
    ZEND_ARG_INFO(0, id)
    ZEND_ARG_INFO(0, host)
    ZEND_ARG_INFO(0, expire)
    ZEND_ARG_INFO(0, persistent)
    ZEND_ARG_INFO(0, secret)
    ZEND_ARG_INFO(0, port)
    ZEND_ARG_INFO(0, index)
ZEND_END_ARG_INFO()

/* scache->open, scache->reset, scache->drop,
   scache->status */
ZEND_BEGIN_ARG_INFO_EX(aic_null, 0, 0, 0)
ZEND_END_ARG_INFO()

/* scache->getindex, scache->lasterr */
# define aic_seslong aic_null

/* scache->rename */
ZEND_BEGIN_ARG_INFO_EX(aic_rename, 0, 0, 1)
    ZEND_ARG_INFO(0, newid)
ZEND_END_ARG_INFO()

/* scache->(sh)get, scache->chget, 
   scache->rnpop, scache->rnshift */
ZEND_BEGIN_ARG_INFO_EX(aic_get, 0, 0, 1)
    ZEND_ARG_INFO(0, path)
ZEND_END_ARG_INFO()

/* scache->sh(set), scache->(sh)add, scache->(sh)replace,
   scache->chput, scache->rnpush, scache->rnunshift */
ZEND_BEGIN_ARG_INFO_EX(aic_set, 0, 0, 2)
    ZEND_ARG_INFO(0, path)
    ZEND_ARG_INFO(0, val)
ZEND_END_ARG_INFO()

/* scache->(sh)clear, scache->(sh)exists, scache->chclear,
   scache->rnclear */
ZEND_BEGIN_ARG_INFO_EX(aic_bool, 0, 0, 1)
    ZEND_ARG_INFO(0, path)
ZEND_END_ARG_INFO()

/* scache->(sh)stat, scache->vget, scache->vclear,
   scache->rnsize */
# define aic_long aic_bool

/* scache->coll, scache->move */
ZEND_BEGIN_ARG_INFO_EX(aic_fromto, 0, 0, 2)
    ZEND_ARG_INFO(0, from)
    ZEND_ARG_INFO(0, to)
ZEND_END_ARG_INFO()

/* scache->vadd, scache->vsub, scache->vset */
# define aic_vset aic_set

/* scache->rnrotf, scache->rnrotb */
ZEND_BEGIN_ARG_INFO_EX(aic_roll, 0, 0, 2)
    ZEND_ARG_INFO(0, path)
    ZEND_ARG_INFO(0, hops)
ZEND_END_ARG_INFO()

/* scache->getopt */
ZEND_BEGIN_ARG_INFO_EX(aic_getopt, 0, 0, 1)
    ZEND_ARG_INFO(0, option)
ZEND_END_ARG_INFO()

/* scache->setopt */
ZEND_BEGIN_ARG_INFO_EX(aic_setopt, 0, 0, 2)
    ZEND_ARG_INFO(0, option)
    ZEND_ARG_INFO(0, newval)
ZEND_END_ARG_INFO()

/* scache->srvstats */
# define aic_srvstats aic_null

/* scache->strerror */
ZEND_BEGIN_ARG_INFO_EX(aic_strerror, 0, 0, 1)
    ZEND_ARG_INFO(0, errcode)
ZEND_END_ARG_INFO()

/* scache->iov */
ZEND_BEGIN_ARG_INFO_EX(aic_iov, 0, 0, 1)
    ZEND_ARG_INFO(0, iops)
ZEND_END_ARG_INFO()

# else /* __PHP8_RELAXED_ARGS */

/* scache_open, scache_popen,
   scache_reset, scache_preset */
ZEND_BEGIN_ARG_WITH_RETURN_OBJ_TYPE_MASK_EX(aif_open,
                                            0, 5,
                                            resource,
                                            MAY_BE_FALSE)

    ZEND_ARG_TYPE_INFO(0, id, IS_STRING, 0)
    ZEND_ARG_TYPE_INFO(0, host, IS_STRING, 1)
    ZEND_ARG_OBJ_INFO(0, expire, long, 1)
    ZEND_ARG_OBJ_INFO(0, port, long, 1)
    ZEND_ARG_OBJ_INFO(0, flags, long, 1)

ZEND_END_ARG_INFO()

/* scache_connect, scache_pconnect */
ZEND_BEGIN_ARG_WITH_RETURN_OBJ_TYPE_MASK_EX(aif_connect,
                                            0, 4,
                                            resource,
                                            MAY_BE_FALSE)

    ZEND_ARG_TYPE_INFO(0, id, IS_STRING, 0)
    ZEND_ARG_TYPE_INFO(0, host, IS_STRING, 1)
    ZEND_ARG_TYPE_INFO(0, secret, IS_STRING, 1)
    ZEND_ARG_OBJ_INFO(0, port, long, 1)

ZEND_END_ARG_INFO()

/* scache_connect_fast, scache_pconnect_fast */
ZEND_BEGIN_ARG_WITH_RETURN_OBJ_TYPE_MASK_EX(aif_connect_fast,
                                            0, 5,
                                            resource,
                                            MAY_BE_FALSE)

    ZEND_ARG_TYPE_INFO(0, id, IS_STRING, 0)
    ZEND_ARG_OBJ_INFO(0, index, long, 0)
    ZEND_ARG_TYPE_INFO(0, host, IS_STRING, 1)
    ZEND_ARG_TYPE_INFO(0, secret, IS_STRING, 1)
    ZEND_ARG_OBJ_INFO(0, port, long, 1)

ZEND_END_ARG_INFO()

/* scache_rename */
ZEND_BEGIN_ARG_WITH_RETURN_TYPE_INFO_EX(aif_rename,
                                        0, 2,
                                        _IS_BOOL, 0)

    ZEND_ARG_OBJ_INFO(0, session, resource, 0)
    ZEND_ARG_TYPE_INFO(0, newid, IS_STRING, 0)

ZEND_END_ARG_INFO()

/* scache_drop */
ZEND_BEGIN_ARG_WITH_RETURN_TYPE_INFO_EX(aif_drop,
                                        0, 1,
                                        _IS_BOOL,
                                        0)

    ZEND_ARG_OBJ_INFO(0, session, resource, 0)
    
ZEND_END_ARG_INFO()

/* scache_getopt */
ZEND_BEGIN_ARG_WITH_RETURN_TYPE_INFO_EX(aif_getopt,
                                        0, 2,
                                        IS_MIXED,
                                        0)
    
    ZEND_ARG_OBJ_INFO(0, session, resource, 0)
    ZEND_ARG_OBJ_INFO(0, opt, long, 0)

ZEND_END_ARG_INFO()

/* scache_setopt */
ZEND_BEGIN_ARG_WITH_RETURN_TYPE_INFO_EX(aif_setopt,
                                        0, 3,
                                        IS_MIXED,
                                        0)
    
    ZEND_ARG_OBJ_INFO(0, session, resource, 0)
    ZEND_ARG_OBJ_INFO(0, opt, long, 0)
    ZEND_ARG_TYPE_INFO(0, newval, IS_MIXED, 0)

ZEND_END_ARG_INFO()

/* scache_srvstats */
ZEND_BEGIN_ARG_WITH_RETURN_TYPE_MASK_EX(aif_srvstats,
                                        0, 1,
                                        MAY_BE_FALSE|MAY_BE_ARRAY)

    ZEND_ARG_OBJ_INFO(0, session, resource, 0)

ZEND_END_ARG_INFO()

/* scache_getindex, scache_lasterr */
ZEND_BEGIN_ARG_WITH_RETURN_OBJ_TYPE_MASK_EX(aif_seslong,
                                            0, 1,
                                            long,
                                            MAY_BE_FALSE)

    ZEND_ARG_OBJ_INFO(0, session, resource, 0)
    
ZEND_END_ARG_INFO()

/* scache_strerror */
ZEND_BEGIN_ARG_WITH_RETURN_TYPE_INFO_EX(aif_strerror,
                                        0, 1,
                                        IS_STRING,
                                        0)
    
    ZEND_ARG_OBJ_INFO(0, errcode, long, 0)

ZEND_END_ARG_INFO()

/* scache_iov */
ZEND_BEGIN_ARG_WITH_RETURN_TYPE_MASK_EX(aif_iov,
                                        0, 2,
                                        MAY_BE_FALSE|MAY_BE_ARRAY)

    ZEND_ARG_OBJ_INFO(0, session, resource, 0)
    ZEND_ARG_TYPE_INFO(0, iops, IS_ARRAY, 0)

ZEND_END_ARG_INFO()

/* scache_(sh)get, scache_chget, 
   scache_rnpop, scache_rnshift, scache_rnget */
ZEND_BEGIN_ARG_WITH_RETURN_TYPE_INFO_EX(aif_get,
                                        0, 2,
                                        IS_MIXED,
                                        0)

    ZEND_ARG_OBJ_INFO(0, session, resource, 0)
    ZEND_ARG_TYPE_INFO(0, path, IS_STRING, 0)

ZEND_END_ARG_INFO()

/* scache_(sh)unset, scache_(sh)clear, scache_(sh)exists, 
   scache_chclear, scache_rnclear */
ZEND_BEGIN_ARG_WITH_RETURN_TYPE_INFO_EX(aif_bool,
                                        0, 2,
                                        _IS_BOOL,
                                        0)

    ZEND_ARG_OBJ_INFO(0, session, resource, 0)
    ZEND_ARG_TYPE_INFO(0, path, IS_STRING, 0)

ZEND_END_ARG_INFO()

/* scache_(sh)get, scache_(sh)add, scache_(sh)replace,
   scache_rnpush, scache_snunshift, scache_chput */
ZEND_BEGIN_ARG_WITH_RETURN_TYPE_INFO_EX(aif_set,
                                        0, 3,
                                        _IS_BOOL,
                                        0)

    ZEND_ARG_OBJ_INFO(0, session, resource, 0)
    ZEND_ARG_TYPE_INFO(0, path, IS_STRING, 0)
    ZEND_ARG_TYPE_INFO(0, val, IS_MIXED, 0)

ZEND_END_ARG_INFO()

/* scache_(sh)stat */
ZEND_BEGIN_ARG_WITH_RETURN_OBJ_TYPE_MASK_EX(aif_long,
                                            0, 2,
                                            long,
                                            MAY_BE_FALSE)

    ZEND_ARG_OBJ_INFO(0, session, resource, 0)
    ZEND_ARG_TYPE_INFO(0, path, IS_STRING, 0)

ZEND_END_ARG_INFO()

/* scache_(sh)coll, scache_(sh)move */
ZEND_BEGIN_ARG_WITH_RETURN_TYPE_INFO_EX(aif_fromto,
                                        0, 3,
                                        _IS_BOOL,
                                        0)

    ZEND_ARG_OBJ_INFO(0, session, resource, 0)
    ZEND_ARG_TYPE_INFO(0, path, IS_STRING, 0)
    ZEND_ARG_TYPE_INFO(0, to, IS_STRING, 0)

ZEND_END_ARG_INFO()

/* scache_vset, scache_vsub, scache_vadd */
ZEND_BEGIN_ARG_WITH_RETURN_OBJ_TYPE_MASK_EX(aif_vset,
                                            0, 3,
                                            long,
                                            MAY_BE_FALSE)

    ZEND_ARG_OBJ_INFO(0, session, resource, 0)
    ZEND_ARG_TYPE_INFO(0, path, IS_STRING, 0)
    ZEND_ARG_OBJ_INFO(0, val, long, 0)

ZEND_END_ARG_INFO()

/* scache_rnrotf, scache_rnrotb */
ZEND_BEGIN_ARG_WITH_RETURN_TYPE_INFO_EX(aif_roll,
                                        0, 3,
                                        _IS_BOOL,
                                        0)

    ZEND_ARG_OBJ_INFO(0, session, resource, 0)
    ZEND_ARG_TYPE_INFO(0, path, IS_STRING, 0)
    ZEND_ARG_OBJ_INFO(0, hops, long, 0)

ZEND_END_ARG_INFO()

/* class interface */
ZEND_BEGIN_ARG_INFO_EX(aic___construct, 0, 0, 7)

    ZEND_ARG_TYPE_INFO(0, id, IS_STRING, 0)
    ZEND_ARG_TYPE_INFO(0, host, IS_STRING, 1)
    ZEND_ARG_OBJ_INFO(0, expire, long, 1)
    ZEND_ARG_TYPE_INFO(0, persistent, _IS_BOOL, 1)
    ZEND_ARG_TYPE_INFO(0, secret, IS_STRING, 1)
    ZEND_ARG_OBJ_INFO(0, port, long, 1)
    ZEND_ARG_OBJ_INFO(0, index, long, 1)

ZEND_END_ARG_INFO()

/* scache->open, scache->reset, scache->drop,
   scache->status */
ZEND_BEGIN_ARG_WITH_RETURN_TYPE_INFO_EX(aic_null,
                                        0, 0,
                                        _IS_BOOL,
                                        0)
ZEND_END_ARG_INFO()

/* scache->getindex, scache->lasterr */
ZEND_BEGIN_ARG_WITH_RETURN_OBJ_INFO_EX(aic_seslong,
                                       0, 0,
                                       long,
                                       0)
ZEND_END_ARG_INFO()

/* scache->rename */
ZEND_BEGIN_ARG_WITH_RETURN_TYPE_INFO_EX(aic_rename,
                                        0, 1,
                                        _IS_BOOL,
                                        0)
    
    ZEND_ARG_TYPE_INFO(0, newid, IS_STRING, 0)
    
ZEND_END_ARG_INFO()

/* scache->(sh)get, scache->chget, 
   scache->rnpop, scache->rnshift */
ZEND_BEGIN_ARG_WITH_RETURN_TYPE_INFO_EX(aic_get,
                                        0, 1,
                                        IS_MIXED,
                                        0)
    
    ZEND_ARG_TYPE_INFO(0, path, IS_STRING, 0)
    
ZEND_END_ARG_INFO()

/* scache->sh(set), scache->(sh)add, scache->(sh)replace,
   scache->chput, scache->rnpush, scache->rnunshift */
ZEND_BEGIN_ARG_WITH_RETURN_TYPE_INFO_EX(aic_set,
                                        0, 2,
                                        _IS_BOOL,
                                        0)
    
    ZEND_ARG_TYPE_INFO(0, path, IS_STRING, 0)
    ZEND_ARG_TYPE_INFO(0, val, IS_MIXED, 0)

ZEND_END_ARG_INFO()

/* scache->(sh)clear, scache->(sh)exists, scache->chclear,
   scache->rnclear */
ZEND_BEGIN_ARG_WITH_RETURN_TYPE_INFO_EX(aic_bool,
                                        0, 1,
                                        _IS_BOOL,
                                        0)
    
    ZEND_ARG_TYPE_INFO(0, path, IS_STRING, 0)

ZEND_END_ARG_INFO()

/* scache->(sh)stat, scache->vget, scache->vclear,
   scache->rnsize */
ZEND_BEGIN_ARG_WITH_RETURN_OBJ_INFO_EX(aic_long,
                                       0, 1,
                                       long,
                                       0)

    ZEND_ARG_TYPE_INFO(0, path, IS_STRING, 0)
    
ZEND_END_ARG_INFO()

/* scache->coll, scache->move */
ZEND_BEGIN_ARG_WITH_RETURN_TYPE_INFO_EX(aic_fromto,
                                        0, 2,
                                        _IS_BOOL,
                                        0)

    ZEND_ARG_TYPE_INFO(0, from, IS_STRING, 0)
    ZEND_ARG_TYPE_INFO(0, to, IS_STRING, 0)
    
ZEND_END_ARG_INFO()

/* scache->vadd, scache->vsub, scache->vset */
ZEND_BEGIN_ARG_WITH_RETURN_OBJ_INFO_EX(aic_vset,
                                       0, 2,
                                       long,
                                       0)

    ZEND_ARG_TYPE_INFO(0, path, IS_STRING, 0)
    ZEND_ARG_OBJ_INFO(0, val, long, 0)

ZEND_END_ARG_INFO()

/* scache->rnrotf, scache->rnrotb */
ZEND_BEGIN_ARG_WITH_RETURN_TYPE_INFO_EX(aic_roll,
                                        0, 2,
                                        _IS_BOOL,
                                        0)

    ZEND_ARG_TYPE_INFO(0, path, IS_STRING, 0)
    ZEND_ARG_OBJ_INFO(0, hops, long, 0)

ZEND_END_ARG_INFO()

/* scache->getopt */
ZEND_BEGIN_ARG_WITH_RETURN_TYPE_INFO_EX(aic_getopt,
                                        0, 1,
                                        IS_MIXED,
                                        0)
    
    ZEND_ARG_OBJ_INFO(0, option, long, 0)
    
ZEND_END_ARG_INFO()

/* scache->setopt */
ZEND_BEGIN_ARG_WITH_RETURN_TYPE_INFO_EX(aic_setopt,
                                        0, 2,
                                        IS_MIXED,
                                        0)

    ZEND_ARG_OBJ_INFO(0, option, long, 0)
    ZEND_ARG_TYPE_INFO(0, newval, IS_MIXED, 0)

ZEND_END_ARG_INFO()

/* scache->srvstats */
ZEND_BEGIN_ARG_WITH_RETURN_TYPE_INFO_EX(aic_srvstats,
                                        0, 0,
                                        IS_ARRAY,
                                        0)
ZEND_END_ARG_INFO()

/* scache->strerror */
ZEND_BEGIN_ARG_WITH_RETURN_TYPE_INFO_EX(aic_strerror,
                                        0, 1,
                                        IS_STRING,
                                        0)

    ZEND_ARG_OBJ_INFO(0, errcode, long, 1)

ZEND_END_ARG_INFO()

/* scache->iov */
ZEND_BEGIN_ARG_WITH_RETURN_TYPE_INFO_EX(aic_iov,
                                        0, 1,
                                        IS_ARRAY,
                                        0)
    
    ZEND_ARG_TYPE_INFO(0, iops, IS_ARRAY, 0)
    
ZEND_END_ARG_INFO()

# endif /* __PHP8_RELAXED_ARGS */

#else /* PHP_MAJOR_VERSION < 8 */

/* function interface */
# define aif_open            NULL
# define aif_connect         NULL
# define aif_connect_fast    NULL
# define aif_rename          NULL
# define aif_drop            NULL
# define aif_getopt          NULL
# define aif_setopt          NULL
# define aif_srvstats        NULL
# define aif_seslong         NULL
# define aif_strerror        NULL
# define aif_iov             NULL
# define aif_get             NULL
# define aif_bool            NULL
# define aif_set             NULL
# define aif_long            NULL
# define aif_fromto          NULL
# define aif_vset            NULL
# define aif_roll            NULL

/* class interface */
# define aic___construct     NULL
# define aic_null            NULL
# define aic_seslong         NULL
# define aic_rename          NULL
# define aic_get             NULL
# define aic_set             NULL
# define aic_bool            NULL
# define aic_long            NULL
# define aic_fromto          NULL
# define aic_vset            NULL
# define aic_roll            NULL
# define aic_getopt          NULL
# define aic_setopt          NULL
# define aic_srvstats        NULL
# define aic_strerror        NULL
# define aic_iov             NULL

#endif

#endif /* _PHP_SCACHE_ARGINFO_H_ */
